

if (!exists("wins.rel")) {
    if (!exists("USE.CPP")) USE.CPP <- TRUE
    if (USE.CPP) {
        message("Compiling cppwins.iq in C++")

        library(inline)

        wins.rel <- cxxfunction( signature( r="numeric", rlo="numeric", rhi="numeric" ), plugin="Rcpp", body='
           // Rcerr << "Hello from cppwins!" << "\\n";
           Rcpp::NumericVector xr(r); assert( xr.size() > 0 );
           Rcpp::NumericVector xrlo(rlo);  assert( xr.size() == xrlo.size() );
           Rcpp::NumericVector xrhi(rhi);  assert( xr.size() == xrhi.size() );

           int T= xr.size();
           Rcpp::NumericVector xrout( T );

           for (int t=0; t<T; ++t) {
              if (xrlo[t] < xrhi[t]) {
                 xrout[t]= (xr[t] < xrlo[t]) ? xrlo[t] : (xr[t] > xrhi[t]) ? xrhi[t] : xr[t];
              } else {
                 xrout[t]= (xr[t] < xrhi[t]) ? xrhi[t] : (xr[t] > xrlo[t]) ? xrlo[t] : xr[t];  // perverse
              }
           }
           return xrout;   ')
    } else {
        message("Using non-CPP version of wins.rel")

        wins.rel <- cmpfun(function( r, rmin, rmax ) {
            stopifnot( (length(rmin)==length(r)) & (length(rmax)==length(r)) )
            rlower <- ifelse( (rmin<rmax), rmin, rmax )
            rupper <- ifelse( (rmin<rmax), rmax, rmin )
            ifelse( r<rlower, rlower, ifelse(r>rupper, rupper, r) )
        })
        ## or l <- (x-v1)/(v2-v1); ifelse( l<0.0, v1, ifelse( l>1.0, v2, x ))
    }
}


stopifnot( ( wins.rel( c( 4, 4, 4, 4 ), c( -2, -2, 6, 6 ), c( 8, 3, -2, 5 ) ) ) == c( 4, 3, 4, 5 ) )

